# -*- coding: utf-8 -*-
import numpy as np
import RPi.GPIO as IO        # calling for header file which helps us use GPIOâ€™s of PI

import time
import argparse
import signal
import sys

from neopixel import *
from flask import Flask

IO.setwarnings(False)         # do not show any warnings
x = 1
b0 = 0                                    # integers for storing 8 bits
b1 = 0
b2 = 0
b3 = 0
b4 = 0
b5 = 0
b6 = 0
b7 = 0
IO.setmode (IO.BCM)            # programming the GPIO by BCM pin numbers. (like PIN29 asâ€˜GPIO5â€™)
IO.setup(26,IO.IN)                    # initialize GPIO Pins as input
IO.setup(19,IO.IN)
IO.setup(13,IO.IN)
IO.setup(6,IO.IN)
IO.setup(5,IO.IN)
IO.setup(21,IO.IN)
IO.setup(20,IO.IN)
IO.setup(16,IO.IN)

LED_COUNT = 120
LED_PIN = 18
LED_FREQ_HZ = 800000
LED_DMA = 5
LED_BRIGHTNESS = 255
LED_INVERT = False
LED_CHANNEL = 0
LED_STRIP = ws.WS2811_STRIP_GRB

neoColor = Color(255, 0, 0)

def signal_handler(signal, frame):
   ledOn(strip)
   sys.exit(0)

def opt_parse():
   parser = argparse.ArgumentParser()
   parser.add_argument('-c', action='store_true', help='clear the display on exit')
   args = parser.parse_args()
   if args.c:
      signal.signal(signal.SIGINT, signal_handler)

def ledOn(strip, color):
   for i in range(strip.numPixels()):
  	   strip.setPixelColor(i,color)
   strip.show()

def ledOff(strip):
   for i in range(strip.numPixels()):
      strip.setPixelColor(i,Color(0,0,0))
   strip.show()

def ledChangeColor(colorArr):
   neoColor = Color(colorArr[0],colorArr[1],colorArr[2])


audioArr = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
def addArr(element, arr):
    for i in range(len(arr)-1):
        arr[len(arr) - 1 - i] = arr[len(arr) - 1 - (i + 1)]
    arr[0] = element
    return arr

def fftColumnLevel(arr):
	column0 = sum(arr[1:5]) / 5
	column1 = sum(arr[6:10]) / 5
	column2 = sum(arr[11:15]) / 5
	column3 = sum(arr[16:20]) / 5
	column4 = sum(arr[17:25]) / 5
	return [column0 / 8,column1 / 12,column2 / 25,column3 / 10,column4 / 11]

def fftLEDColSet(strip, color, arr):
	for i in range(arr[0]):
		strip.setPixelColor(i,color)
	for i in range(arr[1]):
		strip.setPixelColor(24 - i,color)
	for i in range(arr[2]):
		strip.setPixelColor(48 + i,color)
	for i in range(arr[3]):
		strip.setPixelColor(72 - i,color)
	for i in range(arr[4]):
		strip.setPixelColor(96 + i,color)
	strip.show()

strip = Adafruit_NeoPixel(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, LED_BRIGHTNESS, LED_CHANNEL, LED_STRIP)
opt_parse()
strip.begin()

while 1:                                               # execute loop forever
    if (IO.input(16) == True):
        time.sleep(0.001)
        if (IO.input(16) == True):
            b7=1                                       # if pin19 is high bit7 is true

    if (IO.input(20) == True):
        time.sleep(0.001)
        if (IO.input(20) == True):
            b6=1                                      # if pin13 is high bit6 is true

    if (IO.input(21) == True):
        time.sleep(0.001)
        if (IO.input(21) == True):
            b5=1                                      # if pin6 is high bit5 is true

    if (IO.input(5) == True):
        time.sleep(0.001)
        if (IO.input(5) == True):
            b4=1                                     # if pin5 is high bit4 is true

    if (IO.input(6) == True):
        time.sleep(0.001)
        if (IO.input(6) == True):
            b3=1                                     # if pin22 is high bit3 is true

    if (IO.input(13) == True):
        time.sleep(0.001)
        if (IO.input(13) == True):
            b2=1                                    # if pin27 is high bit2 is true
 
    if (IO.input(19) == True):
        time.sleep(0.001)
        if (IO.input(19) == True):
            b1=1                                    # if pin17 is high bit1 is true

    if (IO.input(26) == True):
        time.sleep(0.001)
        if (IO.input(26) == True):
            b0=1                                    # if pin4 is high bit0 is true
    
    x = (1*b0)+(2*b1)
    x = x+(4*b2)+(8*b3)
    x = x+(16*b4)+(32*b5)
    x = x+(64*b6)+(128*b7)                    # representing the bit values from LSB to MSB
    addArr(x,audioArr)
    fourier = abs(np.fft.fft(audioArr))
    ledCol = fftColumnLevel(fourier.astype(np.int64))
    print(ledCol)
    fftLEDColSet(strip, Color(255,0,0), ledCol)
    time.sleep(0.01)                                   # wait for 10ms
    for i in range(strip.numPixels()):
       strip.setPixelColor(i,Color(0,0,0))
    strip.show()
    b0 = b1 = b2 = b3 = b4 = b5 = b6 = b7 = 0        # reset values
    


