'use strict';
var Alexa = require('alexa-sdk');
var http = require('http');

var APP_ID = undefined; //OPTIONAL: replace with "amzn1.echo-sdk-ams.app.[your-unique-value-here]";
var SKILL_NAME = 'Light.io';
var piAddr = 'http://f322e49e.ngrok.io' //Change as ngrok changes

exports.handler = function(event, context, callback) {
    var alexa = Alexa.handler(event, context);
    alexa.APP_ID = APP_ID;
    alexa.registerHandlers(handlers);
    alexa.execute();
};

/*
function httpGet(url) {
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open(url, false);
    xmlHttp.send(null);
    return xmlHttp.responseText;
}
*/
var handlers = {
    'LaunchRequest': function () {
        this.emit('LightsOn');
    },
    'GetNewLightIntent': function () {
        this.emit('LightsOn');
    },
    'LightsOn': function () {
        // Turn on Light
        http.get(piAddr + '/ledOnOff/True');
        this.emit(':tell', 'Lights On')
    },
    'LightsOff': function () {
        // Turn off Light
        http.get(piAddr + '/ledOnOff/False');
        this.emit(':tell', 'Lights Off')
    },
    'ChangeColor': function () {
        // Change Color
        var color = this.event.request.intent.slots.Color.value;
        if(color == 'red') {
            http.get(piAddr + '/ledColor/255/0/0');
            this.emit(':tell', 'Lights Changed to red');
        } else if (color == 'green') {
            http.get(piAddr + '/ledColor/0/255/0');
            this.emit(':tell', 'Lights Changed to green');
        } else if (color == 'blue') {
            http.get(piAddr + '/ledColor/0/0/255');
            this.emit(':tell', 'Lights Changed to blue');
        } else if (color == 'purple') {
            http.get(piAddr + '/ledColor/255/0/255');
            this.emit(':tell', 'Lights Changed to purple');
        } else if (color == 'yellow') {
            http.get(piAddr + '/ledColor/255/255/0');
            this.emit(':tell', 'Lights Changed to yellow');
        } else if (color == 'cyan') {
            http.get(piAddr + '/ledColor/0/255/255');
            this.emit(':tell', 'Lights Changed to cyan');
        }
    },
    'AMAZON.HelpIntent': function () {
        var speechOutput = "You can say tell me a space fact, or, you can say exit... What can I help you with?";
        var reprompt = "What can I help you with?";
        this.emit(':ask', speechOutput, reprompt);
    },
    'AMAZON.CancelIntent': function () {
        this.emit(':tell', 'Goodbye!');
    },
    'AMAZON.StopIntent': function () {
        this.emit(':tell', 'Goodbye!');
    }
};
