'use strict';
var Alexa = require('alexa-sdk');

var APP_ID = undefined; //OPTIONAL: replace with "amzn1.echo-sdk-ams.app.[your-unique-value-here]";
var SKILL_NAME = 'Light.io';
var piAddr = 'http://51f201db.ngrok.io/' //Change as ngrok changes

exports.handler = function(event, context, callback) {
    var alexa = Alexa.handler(event, context);
    alexa.APP_ID = APP_ID;
    alexa.registerHandlers(handlers);
    alexa.execute();
};

function httpGet(url) {
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open("GET", url, false);
    xmlHttp.send(null);
    return xmlHttp.responseText;
}

var handlers = {
    'LaunchRequest': function () {
        this.emit('LightsOn');
    },
    'GetNewLightIntent': function () {
        this.emit('LightsOn');
    },
    'LightsOn': function () {
        // Turn on Light
        httpGet(piAddr + '/ledOnOff/True')
        this.emit(':tell', 'Lights On')
    },
    'LightsOff': function () {
        // Turn on Light
        httpGet(piAddr + '/ledOnOff/False')
        this.emit(':tell', 'Lights Off')
    },
    'AMAZON.HelpIntent': function () {
        var speechOutput = "You can say tell me a space fact, or, you can say exit... What can I help you with?";
        var reprompt = "What can I help you with?";
        this.emit(':ask', speechOutput, reprompt);
    },
    'AMAZON.CancelIntent': function () {
        this.emit(':tell', 'Goodbye!');
    },
    'AMAZON.StopIntent': function () {
        this.emit(':tell', 'Goodbye!');
    }
};